/**
  * @file ArvicolaTerrestris.cpp
  * @author ...
  * ...
  * @@tag Statechart@vle.extension.fsa @@namespace:tp3_2_correction;class:ArvicolaTerrestris;400|400;s:AfterTunnel,226,263,50,50,0,,,,|BeforeTunnel,167,96,107,50,1,,,,|;t:BeforeTunnel,AfterTunnel,,,,,,,170414864,257/146!259/263!|;T:1.0@@end tag@@
  */

#include <vle/extension/fsa/Statechart.hpp>

//@@begin:include@@

//@@end:include@@
namespace vd = vle::devs;
namespace vf = vle::extension::fsa;
namespace vv = vle::value;

namespace tp3_2_correction {

class ArvicolaTerrestris : public vf::Statechart
{
    enum state_t { AfterTunnel, BeforeTunnel };

public:
    ArvicolaTerrestris(
       const vd::DynamicsInit& init,
       const vd::InitEventList& evts)
        : vf::Statechart(init, evts)
    {
//@@begin:constructorUser@@


//@@end:constructorUser@@
      // structure
        states(this) << AfterTunnel << BeforeTunnel;

        transition(this, BeforeTunnel, AfterTunnel)
        << when(&ArvicolaTerrestris::dateTunnel)
        << send(&ArvicolaTerrestris::cutRoot);
        initialState(BeforeTunnel);
    }

    virtual ~ArvicolaTerrestris()
    {}

private:
//@@begin:definitionUser@@
    void cutRoot(const vd::Time&,vd::ExternalEventList& output)
    {
        vd::ExternalEvent* order = new vd::ExternalEvent("RootDepth");
        order->putAttribute("name", new vv::String("RootDepth"));
        order->putAttribute("value", new vv::Double(700));
        output.push_back(order);
    }
    vd::Time dateTunnel(const vd::Time&)
    {
       return vd::Time((double)
       vle::utils::DateTime::toJulianDayNumber("2007-03-27"));
    }
//@@end:definitionUser@@
};

} // namespace tp3_2_correction

DECLARE_DYNAMICS(tp3_2_correction::ArvicolaTerrestris)

