/**
  * @file ThermalTime.cpp
  * @author ...
  * ...
  * @@tag DifferenceEquationMultiple@vle.extension.difference-equation @@namespace:tp3_2_correction;class:ThermalTime;par:;sync:Tmin|Tmax|;nosync:@@end tag@@
  */

#include <vle/extension/DifferenceEquation.hpp>

//@@begin:includes@@
//@@end:includes@@

namespace vd = vle::devs;
namespace ve = vle::extension;
namespace vv = vle::value;

namespace tp3_2_correction {

class ThermalTime : public ve::DifferenceEquation::Multiple
{
public:
    ThermalTime(
       const vd::DynamicsInit& atom,
       const vd::InitEventList& evts)
        : ve::DifferenceEquation::Multiple(atom, evts)
    {
        ThermTime = createVar("ThermTime");
        Tmin = createSync("Tmin");
        Tmax = createSync("Tmax");
    }

    virtual ~ThermalTime()
    {}

//@@begin:compute@@
virtual void compute(const vd::Time& /*time*/)
{
ThermTime = ThermTime(-1) + std::max(0.0, (Tmin()+Tmax())/2);
}
//@@end:compute@@

//@@begin:initValue@@
virtual void initValue(const vd::Time& /*time*/)
{ }
//@@end:initValue@@

private:
//@@begin:user@@
//@@end:user@@

    Var ThermTime;
    Sync Tmin;
    Sync Tmax;
};

} // namespace tp3_2_correction

DECLARE_DYNAMICS(tp3_2_correction::ThermalTime)

