/**
 * @file vle/share/template/package/src/simple.cpp
 * @author The VLE Development Team
 */

/*
 * VLE Environment - the multimodeling and simulation environment
 * This file is a part of the VLE environment (http://vle.univ-littoral.fr)
 * Copyright (C) 2003 - 2009 The VLE Development Team
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#define BOOST_TEST_MAIN
#define BOOST_AUTO_TEST_MAIN
#define BOOST_TEST_DYN_LINK
#define BOOST_TEST_MODULE test_tp3_2_correction
#include <boost/test/unit_test.hpp>
#include <boost/test/auto_unit_test.hpp>
#include <boost/test/floating_point_comparison.hpp>
#include <tester/TesterSimulation.hpp>

BOOST_AUTO_TEST_CASE(test_tp3_2_correction)
{
    namespace vz = vle::vpz;
    namespace vu = vle::utils;
    namespace vm = vle::manager; 
    namespace va = vle::value;
  
    tester::TesterSimulation tsim("tp3_2_correction");
    const va::ConstVectorView& col = tsim.simulates("tp3_2_correction.vpz",
            "vue","model:RootGrowth","RootDepth");

    //check RootDepth line 207
    BOOST_REQUIRE_CLOSE(va::toDouble(col[207]), 966.56, 10e-5);
    //check RootDepth line 208 (day of perturbation)
    BOOST_REQUIRE_CLOSE(va::toDouble(col[208]), 700, 10e-5);
}

